Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 3211)
@@ -46,6 +46,8 @@
    !                                                                !! Griffies operator
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)     ::   wslp2                !: wslp**2 from Griffies quarter cells
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:,:) ::   triadi_g, triadj_g   !: skew flux  slopes relative to geopotentials 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:,:) ::   triadi  , triadj     !: isoneutral slopes relative to model-coordinate
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:,:) ::   &
+             &   triadi_g, triadj_g   !: skew flux  slopes relative to geopotentials 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:,:) ::   &
+             &   triadi  , triadj     !: isoneutral slopes relative to model-coordinate
 
    !                                                              !! Madec operator
@@ -62,4 +64,14 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   zdzrho , zdyrho, zdxrho     ! Horizontal and vertical density gradients
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   zti_mlb, ztj_mlb            ! for Griffies operator only
+
+   !! * Control permutation of array indices
+#  include "ldfslp_ftrans.h90"
+!FTRANS zdxrho :I :I :z :
+!FTRANS zdyrho :I :I :z :
+!FTRANS zdzrho :I :I :z :
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
 
    !! * Substitutions
@@ -119,6 +131,15 @@
       USE oce     , ONLY:   zgrv => ta       , zwz => sa   ! (ta,sa) used as workspace
       USE wrk_nemo, ONLY:   zdzr => wrk_3d_1               ! 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zgru :I :I :z
+!FTRANS zww  :I :I :z
+!FTRANS zgrv :I :I :z
+!FTRANS zwz  :I :I :z
+!FTRANS zdzr :I :I :z
+
       !!
       INTEGER , INTENT(in)                   ::   kt    ! ocean time-step index
+!FTRANS prd :I :I :z
+!FTRANS pn2 :I :I :z
       REAL(wp), INTENT(in), DIMENSION(:,:,:) ::   prd   ! in situ density
       REAL(wp), INTENT(in), DIMENSION(:,:,:) ::   pn2   ! Brunt-Vaisala frequency (locally ref.)
@@ -145,7 +166,13 @@
       zwz(:,:,:) = 0._wp
       !
+#if defined key_z_first
+      DO jj = 1, jpjm1           !==   i- & j-gradient of density   ==!
+         DO ji = 1, jpim1
+            DO jk = 1, jpk
+#else
       DO jk = 1, jpk             !==   i- & j-gradient of density   ==!
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                zgru(ji,jj,jk) = umask(ji,jj,jk) * ( prd(ji+1,jj  ,jk) - prd(ji,jj,jk) ) 
                zgrv(ji,jj,jk) = vmask(ji,jj,jk) * ( prd(ji  ,jj+1,jk) - prd(ji,jj,jk) ) 
@@ -154,5 +181,6 @@
       END DO
       IF( ln_zps ) THEN                           ! partial steps correction at the bottom ocean level
-# if defined key_vectopt_loop  
+!! DCSE_NEMO: Attention! key_vectopt_loop will break key_z_first
+# if ( defined key_vectopt_loop ) && ! ( defined key_z_first ) 
          DO jj = 1, 1
             DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
@@ -167,4 +195,15 @@
       ENDIF
       !
+#if defined key__first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            zdzr(ji,jj,1) = 0._wp   !==   Local vertical density gradient at T-point   == !   (evaluated from N^2)
+            DO jk = 2, jpkm1
+               zdzr(ji,jj,jk) = zm1_g * ( prd(ji,jj,jk) + 1._wp )              &
+                  &                   * ( pn2(ji,jj,jk) + pn2(ji,jj,jk+1) ) * ( 1._wp - 0.5_wp * tmask(ji,jj,jk+1) )
+            END DO
+         END DO
+      END DO
+#else
       zdzr(:,:,1) = 0._wp        !==   Local vertical density gradient at T-point   == !   (evaluated from N^2)
       DO jk = 2, jpkm1
@@ -177,4 +216,5 @@
             &                 * ( pn2(:,:,jk) + pn2(:,:,jk+1) ) * ( 1._wp - 0.5_wp * tmask(:,:,jk+1) )
       END DO
+#endif
       !
       !                          !==   Slopes just below the mixed layer   ==!
@@ -185,7 +225,13 @@
       ! ===========================      | vslp = d/dj( prd ) / d/dz( prd )
       !               
+#if defined key_z_first
+      DO jj = 2, jpjm1               !* Slopes at u and v points
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1                            !* Slopes at u and v points
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                !                                      ! horizontal and vertical density gradient at u- and v-points
                zau = zgru(ji,jj,jk) / e1u(ji,jj)
@@ -223,7 +269,13 @@
       !
       !                                            !* horizontal Shapiro filter
+#if defined key_z_first
+      DO jj = 2, jpjm1, MAX(1, jpj-3)                        ! rows jj=2 and =jpjm1 only
+         DO ji = 2, jpim1  
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1, MAX(1, jpj-3)                        ! rows jj=2 and =jpjm1 only
             DO ji = 2, jpim1  
+#endif
                uslp(ji,jj,jk) = z1_16 * (        zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)      &
                   &                       +      zwz(ji-1,jj+1,jk) + zwz(ji+1,jj+1,jk)      &
@@ -238,6 +290,13 @@
             END DO
          END DO
+#if defined key_z_first
+      END DO
+      DO jj = 3, jpj-2                               ! other rows
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
          DO jj = 3, jpj-2                               ! other rows
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                uslp(ji,jj,jk) = z1_16 * (        zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)      &
                   &                       +      zwz(ji-1,jj+1,jk) + zwz(ji+1,jj+1,jk)      &
@@ -252,7 +311,15 @@
             END DO
          END DO
+#if defined key_z_first
+      END DO
+      !                                           !* decrease along coastal boundaries
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
          !                                        !* decrease along coastal boundaries
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                uslp(ji,jj,jk) = uslp(ji,jj,jk) * ( umask(ji,jj+1,jk) + umask(ji,jj-1,jk  ) ) * 0.5_wp   &
                   &                            * ( umask(ji,jj  ,jk) + umask(ji,jj  ,jk+1) ) * 0.5_wp
@@ -267,7 +334,13 @@
       ! ===========================      | wslpj = mij( d/dj( prd ) / d/dz( prd )
       !               
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                !                                  !* Local vertical density gradient evaluated from N^2
                zbw = zm1_2g * pn2 (ji,jj,jk) * ( prd (ji,jj,jk) + prd (ji,jj,jk-1) + 2. )
@@ -305,7 +378,13 @@
       !
       !                                           !* horizontal Shapiro filter
+#if defined key_z_first
+      DO jj = 2, jpjm1, MAX(1, jpj-3)                           ! rows jj=2 and =jpjm1 only
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1, MAX(1, jpj-3)                        ! rows jj=2 and =jpjm1 only
             DO ji = 2, jpim1
+#endif
                wslpi(ji,jj,jk) = (        zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)     &
                   &                +      zwz(ji-1,jj+1,jk) + zwz(ji+1,jj+1,jk)     &
@@ -321,6 +400,13 @@
             END DO
          END DO  
+#if defined key_z_first
+      END DO
+      DO jj = 3, jpj-2                                  ! other rows
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
          DO jj = 3, jpj-2                               ! other rows
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                wslpi(ji,jj,jk) = (        zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)     &
                   &                +      zwz(ji-1,jj+1,jk) + zwz(ji+1,jj+1,jk)     &
@@ -336,7 +422,15 @@
             END DO
          END DO
+#if defined key_z_first
+      END DO
+      !                                           !* decrease along coastal boundaries
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
          !                                        !* decrease along coastal boundaries
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                zck =   ( umask(ji,jj,jk) + umask(ji-1,jj,jk) )   &
                   &  * ( vmask(ji,jj,jk) + vmask(ji,jj-1,jk) ) * 0.25
@@ -383,4 +477,14 @@
    END SUBROUTINE ldf_slp
    
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "ldfslp_ftrans.h90"
+!FTRANS zdxrho :I :I :z :
+!FTRANS zdyrho :I :I :z :
+!FTRANS zdzrho :I :I :z :
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
 
    SUBROUTINE ldf_slp_grif ( kt )
@@ -404,4 +508,13 @@
       USE wrk_nemo, ONLY:   zalpha  => wrk_3d_4 , zbeta => wrk_3d_5    ! alpha, beta at T points, at depth fsgdept
       USE wrk_nemo, ONLY:   z1_mlbw => wrk_2d_1
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zdit   :I :I :z
+!FTRANS zdis   :I :I :z
+!FTRANS zdjt   :I :I :z
+!FTRANS zdjs   :I :I :z
+!FTRANS zdkt   :I :I :z
+!FTRANS zdks   :I :I :z
+!FTRANS zalpha :I :I :z
+!FTRANS zbeta  :I :I :z
       !
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
@@ -426,7 +539,13 @@
       CALL eos_alpbet( tsb, zalpha, zbeta )     !==  before thermal and haline expension coeff. at T-points  ==!
       !
+#if defined key_z_first
+      DO jj = 1, jpjm1
+         DO ji = 1, jpim1
+            DO jk = 1, jpkm1                    !==  before lateral T & S gradients at T-level jk  ==!
+#else
       DO jk = 1, jpkm1                          !==  before lateral T & S gradients at T-level jk  ==!
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                zdit(ji,jj,jk) = ( tb(ji+1,jj,jk) - tb(ji,jj,jk) ) * umask(ji,jj,jk)   ! i-gradient of T and S at jj
                zdis(ji,jj,jk) = ( sb(ji+1,jj,jk) - sb(ji,jj,jk) ) * umask(ji,jj,jk)
@@ -437,5 +556,5 @@
       END DO
       IF( ln_zps ) THEN                               ! partial steps: correction at the last level
-# if defined key_vectopt_loop
+# if ( defined key_vectopt_loop ) && ! ( defined key_z_first )
          DO jj = 1, 1
             DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
@@ -452,4 +571,16 @@
       ENDIF
       !
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            zdkt(ji,jj,1) = 0._wp            !==  before vertical T & S gradient at w-level  ==!
+            zdks(ji,jj,1) = 0._wp
+            DO jk = 2, jpk
+               zdkt(ji,jj,jk) = ( tb(ji,jj,jk-1) - tb(ji,jj,jk) ) * tmask(ji,jj,jk)
+               zdks(ji,jj,jk) = ( sb(ji,jj,jk-1) - sb(ji,jj,jk) ) * tmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+#else
       zdkt(:,:,1) = 0._wp                    !==  before vertical T & S gradient at w-level  ==!
       zdks(:,:,1) = 0._wp
@@ -458,11 +589,18 @@
          zdks(:,:,jk) = ( sb(:,:,jk-1) - sb(:,:,jk) ) * tmask(:,:,jk)
       END DO
+#endif
       !
       !
       DO jl = 0, 1                           !==  density i-, j-, and k-gradients  ==!
          ip = jl   ;   jp = jl         ! guaranteed nonzero gradients ( absolute value larger than repsln)
+#if defined key_z_first
+         DO jj = 1, jpjm1                          ! NB: not masked due to the minimum value set
+            DO ji = 1, jpim1
+               DO jk = 1, jpkm1                    ! done each pair of triad
+#else
          DO jk = 1, jpkm1                          ! done each pair of triad
             DO jj = 1, jpjm1                       ! NB: not masked due to the minimum value set
                DO ji = 1, fs_jpim1   ! vector opt. 
+#endif
                   zdxrho_raw = ( zalpha(ji+ip,jj   ,jk) * zdit(ji,jj,jk) + zbeta(ji+ip,jj   ,jk) * zdis(ji,jj,jk) ) / e1u(ji,jj)
                   zdyrho_raw = ( zalpha(ji   ,jj+jp,jk) * zdjt(ji,jj,jk) + zbeta(ji   ,jj+jp,jk) * zdjs(ji,jj,jk) ) / e2v(ji,jj)
@@ -474,7 +612,13 @@
       END DO
      DO kp = 0, 1                           !==  density i-, j-, and k-gradients  ==!
+#if defined key_z_first
+         DO jj = 1, jpj                         ! NB: not masked due to the minimum value set
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1                    ! done each pair of triad
+#else
          DO jk = 1, jpkm1                          ! done each pair of triad
             DO jj = 1, jpj                       ! NB: not masked due to the minimum value set
                DO ji = 1, jpi   ! vector opt. 
+#endif
                   zdzrho_raw = ( zalpha(ji,jj,jk) * zdkt(ji,jj,jk+kp) + zbeta(ji,jj,jk) * zdks(ji,jj,jk+kp) )   &
                      &       / fse3w(ji,jj,jk+kp)
@@ -530,7 +674,13 @@
          DO jl = 0, 1
             ip = jl   ;   jp = jl         ! i- and j-indices of triads (i-k and j-k planes)
+#if defined key_z_first
+            DO jj = 1, jpjm1
+               DO ji = 1, jpim1
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 1, jpjm1
                   DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                      !
                      ! Calculate slope relative to geopotentials used for GM skew fluxes
@@ -605,4 +755,14 @@
    END SUBROUTINE ldf_slp_grif
 
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "ldfslp_ftrans.h90"
+!FTRANS zdxrho :I :I :z :
+!FTRANS zdyrho :I :I :z :
+!FTRANS zdzrho :I :I :z :
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
 
    SUBROUTINE ldf_slp_mxl( prd, pn2, p_gru, p_grv, p_dzr )
@@ -622,4 +782,9 @@
       !!                omlmask         :  mixed layer mask
       !!----------------------------------------------------------------------
+!FTRANS prd   :I :I :z
+!FTRANS pn2   :I :I :z
+!FTRANS p_gru :I :I :z
+!FTRANS p_grv :I :I :z
+!FTRANS p_dzr :I :I :z
       REAL(wp), DIMENSION(:,:,:), INTENT(in) ::   prd            ! in situ density
       REAL(wp), DIMENSION(:,:,:), INTENT(in) ::   pn2            ! Brunt-Vaisala frequency (locally ref.)
@@ -646,5 +811,5 @@
       !                          !==   surface mixed layer mask   !
       DO jk = 1, jpk                      ! =1 inside the mixed layer, =0 otherwise
-# if defined key_vectopt_loop
+# if ( defined key_vectopt_loop ) && ! ( defined key_z_first )
          DO jj = 1, 1
             DO ji = 1, jpij   ! vector opt. (forced unrolling)
@@ -672,5 +837,5 @@
       !-----------------------------------------------------------------------
       !
-# if defined key_vectopt_loop
+# if ( defined key_vectopt_loop ) && ! ( defined key_z_first )
       DO jj = 1, 1
          DO ji = jpi+2, jpij-jpi-1   ! vector opt. (forced unrolling)
@@ -727,4 +892,14 @@
    END SUBROUTINE ldf_slp_mxl
 
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "ldfslp_ftrans.h90"
+!FTRANS zdxrho :I :I :z :
+!FTRANS zdyrho :I :I :z :
+!FTRANS zdzrho :I :I :z :
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
 
    SUBROUTINE ldf_slp_init
@@ -780,7 +955,13 @@
             ! set the slope of diffusion to the slope of s-surfaces
             !      ( c a u t i o n : minus sign as fsdep has positive value )
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  DO jk = 1, jpk
+#else
             DO jk = 1, jpk
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      uslp (ji,jj,jk) = -1./e1u(ji,jj) * ( fsdept(ji+1,jj,jk) - fsdept(ji ,jj ,jk) ) * umask(ji,jj,jk)
                      vslp (ji,jj,jk) = -1./e2v(ji,jj) * ( fsdept(ji,jj+1,jk) - fsdept(ji ,jj ,jk) ) * vmask(ji,jj,jk)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp_ftrans.h90	(revision 3211)
@@ -0,0 +1,31 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  ldfslp_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : Directives to control permutation of array indices for
+   !!   public multi-dimensional arrays with a z-dimension declared in module
+   !!   ldfslp.  It should be included wherever the module is used,
+   !!   and updated whenever a new array is added to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+
+!FTRANS triadi_g :I :I :z : :
+!FTRANS triadj_g :I :I :z : :
+!FTRANS wslp2 :I :I :z
+!FTRANS triadi :I :I :z : :
+!FTRANS triadj :I :I :z : :
+!FTRANS uslp :I :I :z
+!FTRANS vslp :I :I :z
+!FTRANS wslpi :I :I :z
+!FTRANS wslpj :I :I :z
+!FTRANS omlmask :I :I :z
+
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra.F90	(revision 3211)
@@ -29,4 +29,10 @@
 
    PUBLIC   ldf_tra_init   ! called by opa.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
 
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_oce.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_oce.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_oce.F90	(revision 3211)
@@ -36,11 +36,15 @@
 
 #if defined key_traldf_c3d
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ahtt, ahtu, ahtv, ahtw   !: ** 3D coefficients ** at T-,U-,V-,W-points
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ahtt, ahtu, ahtv, ahtw   !: ** 3D coefficients **
+   !                                                                                   !  at T-,U-,V-,W-points
 #elif defined key_traldf_c2d
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ahtt, ahtu, ahtv, ahtw   !: ** 2D coefficients ** at T-,U-,V-,W-points
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ahtt, ahtu, ahtv, ahtw   !: ** 2D coefficients **
+   !                                                                                   !  at T-,U-,V-,W-points
 #elif defined key_traldf_c1d
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)     ::   ahtt, ahtu, ahtv, ahtw   !: ** 1D coefficients ** at T-,U-,V-,W-points
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)     ::   ahtt, ahtu, ahtv, ahtw   !: ** 1D coefficients ** 
+   !                                                                                   !  at T-,U-,V-,W-points
 #else
-   REAL(wp), PUBLIC                                      ::   ahtt, ahtu, ahtv, ahtw   !: ** 0D coefficients ** at T-,U-,V-,W-points
+   REAL(wp), PUBLIC                                      ::   ahtt, ahtu, ahtv, ahtw   !: ** 0D coefficients ** !
+   !                                                                                   !  at T-,U-,V-,W-points
 #endif
 
@@ -72,4 +76,7 @@
    REAL(wp), PUBLIC            ::   aeiu, aeiv, aeiw            !: eddy induced coef. (not used)
 #endif
+
+   !! * Control permutation of array indices
+#  include "ldftra_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_oce_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_oce_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_oce_ftrans.h90	(revision 3211)
@@ -0,0 +1,34 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  ldftra_oce_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : Directives to control permutation of array indices
+   !!   for multi-dimensional arrays with a z-dimension declared in module
+   !!   ldftra_oce.  It should be included wherever the module is used,
+   !!   and updated whenever a new array is added to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+
+#if defined key_traldf_c3d
+!FTRANS ahtt ahtu ahtv ahtw :I :I :z
+#endif
+
+#if defined key_traldf_eiv
+#if defined key_traldf_c3d 
+!FTRANS aeiu aeiv aeiw :I :I :z
+#endif
+#endif
+
+#if defined key_diaeiv
+!FTRANS u_eiv v_eiv w_eiv :I :I :z
+#endif
+
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obc_oce.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obc_oce.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obc_oce.F90	(revision 3211)
@@ -219,4 +219,7 @@
       !                                                   !  (repsectively) at the south OB (u_cynbnd = cx rdt )
    REAL(wp), ALLOCATABLE, SAVE,     DIMENSION(:,:) ::   usmsk, vsmsk, tsmsk  !: 2D mask for the South OB
+
+   !! * Control permutation of array indices
+#  include "obc_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obc_oce_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obc_oce_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obc_oce_ftrans.h90	(revision 3211)
@@ -0,0 +1,86 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  obc_oce_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : Directives to control permutation of array indices
+   !!   for multi-dimensional arrays with a z-dimension declared in module
+   !!   oce.  It should be included wherever the module is used,
+   !!   and updated whenever a new array is added to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+
+!! East open boundary
+!FTRANS ufoe :I :z 
+!FTRANS vfoe :I :z 
+!FTRANS tfoe :I :z 
+!FTRANS sfoe :I :z 
+!FTRANS uclie :I :z 
+!! Arrays for radiative East OBC
+!FTRANS uebnd :I :z : :
+!FTRANS vebnd :I :z : :
+!FTRANS tebnd :I :z : :
+!FTRANS sebnd :I :z : :
+!FTRANS u_cxebnd :I :z
+!FTRANS v_cxebnd :I :z
+!FTRANS uemsk :I :z
+!FTRANS vemsk :I :z
+!FTRANS temsk :I :z
+!! West open boundary
+!FTRANS ufow :I :z
+!FTRANS vfow :I :z
+!FTRANS tfow :I :z
+!FTRANS sfow :I :z
+!FTRANS ucliw :I :z
+!! Arrays for radiative West OBC
+!FTRANS uwbnd :I :z : :
+!FTRANS vwbnd :I :z : :
+!FTRANS twbnd :I :z : :
+!FTRANS swbnd :I :z : :
+!FTRANS u_cxwbnd :I :z
+!FTRANS v_cxwbnd :I :z
+!FTRANS uwmsk :I :z
+!FTRANS vwmsk :I :z
+!FTRANS twmsk :I :z
+!! North open boundary
+!FTRANS ufon :I :z
+!FTRANS vfon :I :z
+!FTRANS tfon :I :z
+!FTRANS sfon :I :z
+!FTRANS vclin :I :z
+!! Arrays for radiative North OBC
+!FTRANS unbnd :I :z : :
+!FTRANS vnbnd :I :z : :
+!FTRANS tnbnd :I :z : :
+!FTRANS snbnd :I :z : :
+!FTRANS u_cynbnd :I :z
+!FTRANS v_cynbnd :I :z
+!FTRANS unmsk :I :z
+!FTRANS vnmsk :I :z
+!FTRANS tnmsk :I :z
+!! South open boundary
+!FTRANS ufos :I :z
+!FTRANS vfos :I :z
+!FTRANS tfos :I :z
+!FTRANS sfos :I :z
+!FTRANS vclis :I :z
+!! Arrays for radiative South OBC
+!FTRANS usbnd :I :z : :
+!FTRANS vsbnd :I :z : :
+!FTRANS tsbnd :I :z : :
+!FTRANS ssbnd :I :z : :
+!FTRANS u_cysbnd :I :z
+!FTRANS v_cysbnd :I :z
+!FTRANS usmsk :I :z
+!FTRANS vsmsk :I :z
+!FTRANS tsmsk :I :z
+
+
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obc_vectopt_loop_substitute.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obc_vectopt_loop_substitute.h90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obc_vectopt_loop_substitute.h90	(revision 3211)
@@ -2,5 +2,5 @@
    !!                 ***  obc_vectopt_loop_substitute.h90  ***
    !!----------------------------------------------------------------------
-   !! ** purpose :   substitute the inner loop starting and inding indices 
+   !! ** purpose :   substitute the inner loop starting and ending indices 
    !!      to allow unrolling of do-loop using CPP macro.
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcdta.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 3211)
@@ -54,7 +54,7 @@
    INTEGER ::   nt_m=0, ntobc_m
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: ubtedta, vbtedta, sshedta    ! East
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: ubtwdta, vbtwdta, sshwdta	   ! West
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: ubtndta, vbtndta, sshndta	   ! North
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: ubtsdta, vbtsdta, sshsdta	   ! South
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: ubtwdta, vbtwdta, sshwdta    ! West
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: ubtndta, vbtndta, sshndta    ! North
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: ubtsdta, vbtsdta, sshsdta    ! South
    ! arrays used for interpolating time dependent data on the boundaries
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: uedta, vedta, tedta, sedta    ! East
@@ -68,4 +68,18 @@
    LOGICAL , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: ltnmsk, lunmsk, lvnmsk  ! checks
    LOGICAL , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: ltsmsk, lusmsk, lvsmsk
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
+   !! No public arrays in this module require index permutation
+!FTRANS uedta vedta tedta sedta :I :z :
+!FTRANS uwdta vwdta twdta swdta :I :z :
+!FTRANS undta vndta tndta sndta :I :z :
+!FTRANS usdta vsdta tsdta ssdta :I :z :
+!FTRANS ltemsk luemsk lvemsk :I :z
+!FTRANS ltwmsk luwmsk lvwmsk :I :z
+!FTRANS ltnmsk lunmsk lvnmsk :I :z
+!FTRANS ltsmsk lusmsk lvsmsk :I :z
 
    !! * Substitutions
